#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "ProbabilisticPacketDropper.h"

ProbabilisticPacketDropper::ProbabilisticPacketDropper (char* ipProbLine) {

  char* lpDelims = ":";
  char* lpToken = strtok( ipProbLine, lpDelims );
  lpToken = strtok(NULL, lpDelims);
  
  if (sscanf(lpToken, "%f", &mDropProbability) != 1) {
      printf ("MNL: ProbabilisticPacketDropper: Error: Invalid probability %s\n",
              lpToken
            );
      exit (1);
    }

}

bool ProbabilisticPacketDropper::IsDropPkt() {

  float lTmpToss = (1.0 * rand()/RAND_MAX);
  if (lTmpToss < mDropProbability) {
    return true;
  } else {
    return false;
  }
}
