#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <assert.h>

#include "SpecificPacketDropper.h"

SpecificPacketDropper::SpecificPacketDropper(char* ipPktLine) {

  printf ("-->%s!\n", ipPktLine);
  char* lpDelims = ":";
  char* lpToken = strtok( ipPktLine, lpDelims );
  lpToken = strtok(NULL, lpDelims);
  while( lpToken != NULL) {
    int lTmpPktNum = atoi(lpToken);
    if(lTmpPktNum == 0) {
      printf ("MNL: SpecificPacketDropper: Error: Invalid packet %d\n", lTmpPktNum);
      exit(1);
    }
    mToDropList.push(lTmpPktNum);
    
    printf ("MNL: SpecificPacketDropper: Will drop pkt %d\n",
              lTmpPktNum
            );
      
    lpToken = strtok( NULL, lpDelims );
  }            
}

bool SpecificPacketDropper::IsDropPkt() {
 
  if (mToDropList.empty()) {
    return false;
  }
  
  int lTmpPktNum = mToDropList.front();
  if (lTmpPktNum == mSentPktCount + 1) {
    mToDropList.pop();
    return true;
  } else if (lTmpPktNum < mSentPktCount + 1) {
    printf ("--->%d %d\n", lTmpPktNum,mSentPktCount + 1);
    assert(false);
  }
  return false;
}
