#ifndef MNLDaemon_h
#define MNLDaemon_h

#include <inttypes.h>

class SendQueue;
class PacketDropper;

class MNLDaemon {

public:

  ~MNLDaemon();

  bool Init(const char* ipCfgFileName);
  void MainLoop();

private:

  void ProcessClientMsg();
  bool InitListenSkt();
  bool ReadCfgFile(const char* ipCfgFileName);

  PacketDropper* mpPktDropper;

  uint32_t mRTTMean;
  uint32_t mRTTVar;

  int mListenSkt;

  SendQueue* mpSendQueue;

};

#endif //MNLDaemon_h
