#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "PacketBuf.h"

PacketBuf* PacketBuf::Create(SendMsg* ipSendMsg, struct timeval iToSendTime) {

  if (ipSendMsg->mPktLen > MAX_PKT_LEN) {
    return NULL;
  } else {
    return new PacketBuf(ipSendMsg, iToSendTime);
  }
}

PacketBuf::PacketBuf(SendMsg* ipSendMsg, struct timeval iToSendTime) {

  mPktLen = ipSendMsg->mPktLen;
  memcpy(mpPktContents, ipSendMsg->mpPktContents, mPktLen);
  mToAddr = ipSendMsg->mToAddr;
  mToLen = ipSendMsg->mToLen;
  mFlags = ipSendMsg->mFlags;
  mSeqNumStart = ipSendMsg->mSeqNumStart;
  mDataLen = ipSendMsg->mDataLen;
  mWindowSize = ipSendMsg->mWindowSize;

  mToSendTime = iToSendTime;
  
}
