#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "PeriodicPacketDropper.h"

PeriodicPacketDropper::PeriodicPacketDropper (char* ipLine) {
  char* lpDelims = ":";
  char* lpToken = strtok( ipLine, lpDelims );
  lpToken = strtok(NULL, lpDelims);

  mDropPeriod = atoi(lpToken);
  if (mDropPeriod == 0) {
    printf ("MNL:PeriodicPacketDropper: Invalid period %s\n", lpToken);
    exit(1);
  }
}

bool PeriodicPacketDropper::IsDropPkt() {
  if ((mSentPktCount + 1) % mDropPeriod == 0) {
    return true;
  } else {
    return false;
  }
}
